package sexpression;

@DisplayName("nil")
public class Nil extends Cons {

    private static Nil uniqueInstance = new Nil();

    public static Nil getInstance() {
        return uniqueInstance;
    }

    private Nil() {
        super(null, null);

        super.setCar(this);
        super.setCdr(this);
    }

    public boolean nullp() {
        return true;
    }

    public boolean atomp() {
        return true;
    }

    public boolean consp() {
        return false;
    }

    public boolean symbolp() {
        return true;
    }

    /**
     * The car of NIL can not be changed.
     */
    public void setCar(SExpression newCar) {}

    /**
     * The cdr of NIL can not be changed.
     */
    public void setCdr(SExpression newCdr) {}

    public String toString() {
        return "NIL";
    }

}
